/*
 * ObjectFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef OBJECT_FROM_STRING_LEXER_H_
#define OBJECT_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace alib {

class ObjectFromStringLexer {
public:
	enum class TokenType {
		STRING,
		INTEGER,
		SET_BEGIN,
		SET_END,
		PAIR_BEGIN,
		PAIR_END,
		COMMA,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream& input, Token token);
};

} /* namespace alib */

#endif /* OBJECT_FROM_STRING_LEXER_H_ */
